package middletier;

import java.util.Vector;

public class PersonDataCache {
    
    // ATTRIBUTI
    Vector personList = new Vector();
    int cursorIndex = 0;
    
    // COSTRUTTORE DI DEFAULT
    public PersonDataCache() {
        // aggiunge un solo elemento, vuoto
        personList.addElement(new Person("","",""));
    }

    public PersonDataCache(Vector p_vector) {
        personList = p_vector;
    }
    
    // METODI

    /**
     * @return Person
     */
    public Person getFirst() {
        if (personList != null) {
            Person temp = (Person) personList.elementAt(0);
            if (temp != null) {
                cursorIndex = 0;
                return temp;
            }
            else {
                return new Person("","","");   
            }
        }
        else {
            return new Person("","","");   
        }
    }
    
    public Person getLast() {
        if (personList != null) {
            Person temp = (Person) personList.elementAt(personList.size()-1);
            if (temp != null) {
                cursorIndex = personList.size() - 1;
                return temp;
            }
            else {
                return new Person("","","");   
            }
        }
        else {
            return new Person("","","");   
        }
    }
    
    public Person getNext() {
    
        if (personList != null) {
            if (cursorIndex < personList.size() - 1) {
                cursorIndex = cursorIndex + 1;
            }
            Person temp = (Person) personList.elementAt(cursorIndex);
            if (temp != null) {
                return temp;
            }
            else {
                cursorIndex = cursorIndex - 1;
                return new Person("","","");   
            }
        }
        else {
            return new Person("","","");   
        }
    }

    public Person getPrev() {
        if (personList != null) {
            if (cursorIndex > 0) {
                cursorIndex = cursorIndex - 1;
            }
            Person temp = (Person) personList.elementAt(cursorIndex);
            if (temp != null) {
                return temp;
            }
            else {
                cursorIndex = cursorIndex + 1;
                return new Person("","","");   
            }
        }
        else {
            return new Person("","","");   
        }
    }

    public Person getElementAt(int p_index) {
        if (personList != null) {
            if ((p_index > 0) && (p_index < personList.size())) {
                Person temp = (Person) personList.elementAt(cursorIndex);            
                if (temp != null) {
                    return temp;
                }
                else {
                    return new Person("","","");   
                }
            }
            else {
                return new Person("","","");
            }
        }
        else return new Person("","","");
    }
    
    public void setPersonList(Vector personaList) {
        this.personList = personaList;
    }

    public Vector getPersonList() {
        return personList;
    }
    
    public Object[] personToObjectArray(Person p_person) {
        Object[] res = new Object[] {
            (Object) p_person.getFirstName(),
            (Object) p_person.getLastName(),
            (Object) p_person.getCode(),
        };
        return res;
    }
    
    public Object[][] getPersonTableData() {
        Object resArray[][] = new Object[personList.size()][];
        
        for (int i=0; i<personList.size(); i++) {
            resArray[i] = this.personToObjectArray((Person)personList.get(i));
        }
        
        return resArray;
    }
    
    public String[] getPersonTableTitle() {
        return  new String [] {
                "FirstName", "LastName", "Code"
            };
    }
    
    public int size() {
        return personList.size();
    }

    public int getCursorIndex() {
        return cursorIndex;
    }

} // end class PersonDataCache
